%define build_type %(if [[ ${BRANCH_NAME} = *release/* ]]; then echo release; else echo feature; fi)
%define osbuilder_release %{agent_release}
%global _buildhost build-ol%{?oraclelinux}-%{?_arch}.oracle.com

%global cri_o_min 1.21
%global cri_o_max 1.29
%global kata_runtime_version %{version}-11%{dist}
%global kata_proxy_version %{version}-11%{dist}
%global kata_shim_version %{version}-11%{dist}
%global kata_throttler_version %{version}-11%{dist}

# Following are the kata-image versions
%define feature_ol7_x86_64    1.12.1-11.11.ol7_202312211800
%define feature_ol8_x86_64    1.12.1-11.11.ol8_202312211803
%define feature_ol9_x86_64    1.12.1-11.11.ol9_202312211802
%define feature_ol8_aarch64   1.12.1-11.11.ol8_202312211905
%define feature_ol9_aarch64   1.12.1-11.11.ol9_202312211801
%define release_ol7_x86_64    1.12.1-11.11.ol7_202312212315
%define release_ol8_x86_64    1.12.1-11.11.ol8_202312212317
%define release_ol9_x86_64    1.12.1-11.11.ol9_202312212316
%define release_ol8_aarch64   1.12.1-11.11.ol8_202312212317
%define release_ol9_aarch64   1.12.1-11.11.ol9_202312212317

# this is required such that when we merged
# kata meta RPM, it will correctly pointing the kata-image
# that is only and already available in a stable repo (release)
%define tmpvar %{?build_type}_ol%{?oraclelinux}_%{_arch}
%global kata_image_version %{%{?tmpvar}}

%global kernel_uek_container_min 5.4.17-2136.309.5.1%{dist}
%global kernel_uek_container_max 5.16
%global kernel_uek_min 4.14
%global kernel_uek_max 5.16
%global cri_tools_min 1.21
%global cri_tools_max 1.29
%global qemu_kvm_min 4.1.1
%global qemu_min 15:3.1
%global qemu_max 15:4.4

%global _buildhost build-ol%{?oraclelinux}-%{?_arch}.oracle.com

Name:      kata
Version:   1.12.1
Release:   17%{?dist}
Vendor:    Oracle America
Summary:   meta rpm to ease cri-o and kata installation for olcne
Group:     Development/Tools
License:   UPL

Requires: cri-o >= %{cri_o_min}
Requires: cri-o < %{cri_o_max}
Requires: kata-runtime = %{kata_runtime_version}
Requires: kata-proxy = %{kata_proxy_version}
Requires: kata-shim = %{kata_shim_version}
Requires: kata-ksm-throttler = %{kata_throttler_version}
Requires: kata-image = %{kata_image_version}
%if %{?oraclelinux} != 7
Requires: kernel-uek-container >= %{kernel_uek_container_min}
Requires: kernel-uek-container < %{kernel_uek_container_max}
%endif
Requires: kernel-uek >= %{kernel_uek_min}
Requires: kernel-uek < %{kernel_uek_max}
Requires: cri-tools >= %{cri_tools_min}
Requires: cri-tools < %{cri_tools_max}
%if %{?oraclelinux} == 7
Requires: qemu >= %{qemu_min}
Requires: qemu < %{qemu_max}
%endif
%if %{?oraclelinux} == 8
# OL8 doesn't play well with qemu_kvm_max
# it will complain with:
# Error: transaction check vs depsolve:
# qemu-kvm < 5.0.0 is needed by kata-1.12.1-2.el8.x86_64
Requires: qemu-kvm >= %{qemu_kvm_min}
%endif
%if %{?oraclelinux} == 9
Requires: qemu-kvm
%endif


%description
A meta rpm to help facilitate the installation of cri-o and kata related components.

%prep
echo build_type=%{build_type}
echo kata_image_version=%{kata_image_version}

%install

%files

%doc

%post
# we need to make some baseline adjustments to the crio config post installation
checkCrioConf () {
  # arg1 config section, arg2 keyword, arg3 value
  # if keyword is missing, add it and value to config section
  if ! grep -q "^$2" %{_sysconfdir}/crio/crio.conf; then
    sed -i \
        -e "/^$1/a $2 = $3" \
        %{_sysconfdir}/crio/crio.conf
  else
  # keyword is present, ensure it has the correct value
    sed -i \
        -e "s/^$2.*/$2 = $3/" \
        %{_sysconfdir}/crio/crio.conf
  fi
}

checkCrioConf "\[crio.runtime\]" "manage_network_ns_lifecycle" "true"
checkCrioConf "\[crio.runtime\]" "selinux" "false"
checkCrioConf "\[crio.image\]" "registries" "\[\"docker.io\", \"container-registry.oracle.com\"\]"
checkCrioConf "\[crio.image\]" "pause_image_auth_file" "\"\/run\/containers\/0\/auth.json\""
checkCrioConf "\[crio.image\]" "pause_image " "\"container-registry.oracle.com\/kubernetes\/pause:3.1\""

# insert extra config section if it's missing
if ! grep -q "\[crio.runtime.runtimes.kata\]" %{_sysconfdir}/crio/crio.conf; then
  sed -i \
      -e '/\[crio.runtime.runtimes.runc\]/i\
\[crio.runtime.runtimes.kata\]\
runtime_path = \"\/usr\/bin\/kata-runtime\"\
runtime_type = \"oci\"\n'\
      %{_sysconfdir}/crio/crio.conf
fi

%changelog
* Fri Jan 05 2024 Thomas Tanaka <thomas.tanaka@oracle.com> - 1.12.1-17
- Include OL9 for kernel-uek-container (currently in UEKR7_developer_preview)

* Wed Dec 21 2023 Thomas Tanaka <thomas.tanaka@oracle.com> - 1.12.1-16
- Rebuild with golang 1.20.12

* Thu Nov 30 2023 Thomas Tanaka <thomas.tanaka@oracle.com> - 1.12.1-15
- Updated for kubernetes 1.27 and 1.28

* Wed Nov 15 2023 Guoyong Zhang <guoyong.zhang@oracle.com> - 1.12.1-14
- Updated to address CVE-2023-44487 and CVE-2023-39325

* Thu Aug 24 2023 Murali Annamneni <murali.annamneni@oracle.com> - 1.12.1-13
- Rebuild kata to fix timestamp issue

* Thu Aug 03 2023 Murali Annamneni <murali.annamneni@oracle.com> - 1.12.1-12
- Add support for ARM build

* Wed May 31 2023  Michael Thompson <michael.a.thompson@oracle.com> - 1.12.1-11
- Add OL9 support

* Wed Mar 22 2023 Guoyong Zhang <guoyong.zhang@oracle.com> - 1.12.1-10
- Updated kata-runtime version to work with more versions of kvm_utils

* Tue Mar 07 2023 Thomas Tanaka <thomas.tanaka@oracle.com> - 1.21.1-9
- updated cri-o and cri-tools versions to support olcne-1.6.0

* Mon Oct 10 2022 Michael Thompson <michael.a.thompson@oracle.com> - 1.12.1-7
- Updated kernel_uek_max and kernel_uek_container_max to 5.16 to support UEKR7 host and guest kernel.
  Note: installed kernel < 5.16.

* Thu Aug 18 2022 Durai Govindasamy <durai.vattakalvalasu.govindas@oracle.com> - 1.12.1-6
- updated cri-o and cri-tools versions to support olcne-1.5.0

* Wed Jun 22 2022 Durai Govindasamy <durai.vattakalvalasu.govindas@oracle.com> - 1.12.1-5
- updated cri-o and cri-tools versions to support kubernetes-1.23

* Mon Apr 25 2022 Durai Govindasamy <durai.vattakalvalasu.govindas@oracle.com> - 1.12.1-4
- update kata-image versions
- update kernel-uek-container version to kernel-uek-container-5.4.17-2136.306.1.3

* Fri Nov 12 2021 Thomas Tanaka <thomas.tanaka@oracle.com> - 1.21.1-3
- Support k8s 1.21.6
- updated kernel-uek-container version
- updated kata-image versions
- added buildhost variable

* Wed Mar 24 2021 Thomas Tanaka <thomas.tanaka@oracle.com> - 1.12.1-2
- Golang 1.15.9

* Fri Mar 05 2021 Durai Govindasamy <durai.vattakalvalasu.govindas@oracle.com> - 1.12.1-1
- Updated to kata 1.12.1
- Updated guest kernel (kernel-uek-container) minimum version to UEK6U2 (5.4.17-2102.200.7)
